﻿$(window).load(function () {
    //Hide Loader
    $(".site-loader").hide();

    $("body").queryLoader({
        barColor: "#064C8A",
        backgroundColor: "#FFFFFF",
        percentage: true,
        barHeight: 2,
        minimumTime: 100,
        onComplete: function () {
        }
    });
});

var lastId,
     topMenu,
     topMenuHeight,
     menuItems,
     scrollItems;


$(function () {
    // Cache selectors
    topMenu = $("#mainNav"),
    menuItems = topMenu.find("a"),
    scrollItems = menuItems.map(function () {
        var item = $($(this).attr("href"));
        if (item.length) { return item; }
    });

    if ($(window).width() < 960)
        topMenuHeight = 58;
    else
        topMenuHeight = 98;

    $(".scroll-header").click(function (event) {
        $('html,body').animate({ scrollTop: 0 }, 1200);
        event.preventDefault();
        $("#home_menu").addClass("active");
    });

    // Bind click handler to menu items
    // so we can get a fancy scroll animation
    menuItems.click(function (e) {
        var href = $(this).attr("href"),
            offsetTop = href === "#" ? 0 : $(href).offset().top - topMenuHeight + 1;
        $('html, body').stop().animate({
            scrollTop: offsetTop
        }, 1200);
        e.preventDefault();
    });

    //script-nav
    $("span.menu").click(function () {
        $(".top-menu ul").slideToggle("slow", function () {
        });
    });

    $().UItoTop({ easingType: 'easeOutQuart' });

    $("#toTop").on("click", function () {
        $(".scroll").removeClass("active");
        $("#home_menu").addClass("active");
    });

    $(' #da-thumbs > li ').each(function () { $(this).hoverdir(); });

    $(".book-appointment").click(function (event) {
        if ($(this).attr("data-hours") == 'hidden') {
            $(".address").slideUp("slow", function () {
                $(".book-appointment").val("hide timings");
                $(".book-appointment").attr("data-hours", "shown");
                $(".hours").slideDown("slow");
            });
        }
        else {
            $(".hours").slideUp("slow", function () {
                $(".book-appointment").val("show timings");
                $(".book-appointment").attr("data-hours", "hidden");
                $(".address").slideDown("slow");
            });
        }
    });

    $(".show-details").click(function (event) {
        if ($(".details-show").attr("data-doctor-details") == 'hidden') {
            $(".details-hide").slideUp("slow", function () {
                $(".details-show").attr("data-doctor-details", "shown");
                $(".details-show").slideDown("slow");
            });
        }
        else {
            $(".details-show").slideUp("slow", function () {
                $(".details-show").attr("data-doctor-details", "hidden");
                $(".details-hide").slideDown("slow");
            });
        }
    });

    $('<iframe>', {
        src: 'https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d120663.80963700364!2d72.81666486706945!3d19.074987727866823!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x3be7b8e4e3c28a7f%3A0x2ccb839e2a0b118e!2sCentre+for+Medical+Genetics!5e0!3m2!1sen!2sau!4v1485988846300',
        id: 'google_map',
        frameborder: 0,
        scrolling: 'no'
    }).appendTo('.google-map');
});


function emailActionBegin() {
    $("#btnSendEmail").hide();
}

function emailActionComplete() {
    $("#btnSendEmail").show();
}

// Bind to scroll
$(window).scroll(function () {
    // Get container scroll position
    var fromTop = $(this).scrollTop() + topMenuHeight;

    // Get id of current scroll item
    var cur = scrollItems.map(function () {
        if ($(this).offset().top < fromTop)
            return this;
    });
    // Get the id of the current element
    cur = cur[cur.length - 1];
    var id = cur && cur.length ? cur[0].id : "";
    if (lastId !== id) {
        lastId = id;
        // Set/remove active class
        menuItems
          .removeClass("active")
          .filter("[href='#" + id + "']").addClass("active");
    }
});